module.exports =
/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, { enumerable: true, get: getter });
/******/ 		}
/******/ 	};
/******/
/******/ 	// define __esModule on exports
/******/ 	__webpack_require__.r = function(exports) {
/******/ 		if(typeof Symbol !== 'undefined' && Symbol.toStringTag) {
/******/ 			Object.defineProperty(exports, Symbol.toStringTag, { value: 'Module' });
/******/ 		}
/******/ 		Object.defineProperty(exports, '__esModule', { value: true });
/******/ 	};
/******/
/******/ 	// create a fake namespace object
/******/ 	// mode & 1: value is a module id, require it
/******/ 	// mode & 2: merge all properties of value into the ns
/******/ 	// mode & 4: return value when already ns object
/******/ 	// mode & 8|1: behave like require
/******/ 	__webpack_require__.t = function(value, mode) {
/******/ 		if(mode & 1) value = __webpack_require__(value);
/******/ 		if(mode & 8) return value;
/******/ 		if((mode & 4) && typeof value === 'object' && value && value.__esModule) return value;
/******/ 		var ns = Object.create(null);
/******/ 		__webpack_require__.r(ns);
/******/ 		Object.defineProperty(ns, 'default', { enumerable: true, value: value });
/******/ 		if(mode & 2 && typeof value != 'string') for(var key in value) __webpack_require__.d(ns, key, function(key) { return value[key]; }.bind(null, key));
/******/ 		return ns;
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = "./src/FastRTCSwarm.ts");
/******/ })
/************************************************************************/
/******/ ({

/***/ "./src/FastRTCSwarm.ts":
/*!*****************************!*\
  !*** ./src/FastRTCSwarm.ts ***!
  \*****************************/
/*! exports provided: default */
/***/ (function(module, __webpack_exports__, __webpack_require__) {

"use strict";
__webpack_require__.r(__webpack_exports__);
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0__ = __webpack_require__(/*! tslib */ "tslib");
/* harmony import */ var tslib__WEBPACK_IMPORTED_MODULE_0___default = /*#__PURE__*/__webpack_require__.n(tslib__WEBPACK_IMPORTED_MODULE_0__);
/* harmony import */ var _mattkrick_fast_rtc_peer__WEBPACK_IMPORTED_MODULE_1__ = __webpack_require__(/*! @mattkrick/fast-rtc-peer */ "@mattkrick/fast-rtc-peer");
/* harmony import */ var _mattkrick_fast_rtc_peer__WEBPACK_IMPORTED_MODULE_1___default = /*#__PURE__*/__webpack_require__.n(_mattkrick_fast_rtc_peer__WEBPACK_IMPORTED_MODULE_1__);
/* harmony import */ var eventemitter3__WEBPACK_IMPORTED_MODULE_2__ = __webpack_require__(/*! eventemitter3 */ "eventemitter3");
/* harmony import */ var eventemitter3__WEBPACK_IMPORTED_MODULE_2___default = /*#__PURE__*/__webpack_require__.n(eventemitter3__WEBPACK_IMPORTED_MODULE_2__);



class FastRTCSwarm extends eventemitter3__WEBPACK_IMPORTED_MODULE_2___default.a {
    constructor(opts) {
        super();
        this.peers = {};
        this.pendingPeers = {};
        this.onPeerData = (data, peer) => {
            this.emit('data', data, peer);
        };
        this.onPeerDataClose = (peer) => {
            delete this.peers[peer.id];
            this.emit('dataClose', peer);
        };
        this.onPeerDataOpen = (peer) => {
            this.emit('dataOpen', peer);
        };
        this.onPeerStream = (stream, peer) => {
            this.emit('stream', stream, peer);
        };
        this.onPeerSignal = (signal, peer) => {
            const { id } = peer;
            const field = this.peers[id] ? 'to' : 'connectionId';
            switch (signal.type) {
                case 'offer':
                    if (this.isInit) {
                        this.isInit = false;
                        this.emit('signal', { type: 'init', sdp: signal.sdp, connectionId: id, from: this.me });
                    }
                    else {
                        this.emit('signal', { type: 'offer', sdp: signal.sdp, [field]: id });
                    }
                    break;
                case 'candidate':
                    this.emit('signal', { type: 'candidate', candidate: signal.candidate, [field]: id });
                    break;
                case 'answer':
                    this.emit('signal', { type: 'answer', sdp: signal.sdp, to: id });
            }
        };
        const _a = opts || {}, { id } = _a, peerOptions = tslib__WEBPACK_IMPORTED_MODULE_0__["__rest"](_a, ["id"]);
        this.me = id || _mattkrick_fast_rtc_peer__WEBPACK_IMPORTED_MODULE_1___default.a.generateID();
        this.peerOptions = peerOptions;
        this.isInit = true;
        this.createOfferer();
    }
    createOfferer() {
        const connectionId = _mattkrick_fast_rtc_peer__WEBPACK_IMPORTED_MODULE_1___default.a.generateID();
        const offeringPeer = this.initializePeer(Object.assign({ isOfferer: true, id: connectionId }, this.peerOptions));
        this.pendingPeers[connectionId] = offeringPeer;
    }
    initializePeer(config) {
        const peer = new _mattkrick_fast_rtc_peer__WEBPACK_IMPORTED_MODULE_1___default.a(config);
        peer.on('signal', this.onPeerSignal);
        peer.on('dataOpen', this.onPeerDataOpen);
        peer.on('dataClose', this.onPeerDataClose);
        peer.on('data', this.onPeerData);
        peer.on('stream', this.onPeerStream);
        return peer;
    }
    broadcast(message) {
        const peerIds = Object.keys(this.peers);
        for (let ii = 0; ii < peerIds.length; ii++) {
            const peerId = peerIds[ii];
            const peer = this.peers[peerId];
            peer.send(message);
        }
    }
    close() {
        const peerIds = Object.keys(this.peers);
        for (let ii = 0; ii < peerIds.length; ii++) {
            const peerId = peerIds[ii];
            const peer = this.peers[peerId];
            peer.close();
        }
        const connectionIds = Object.keys(this.pendingPeers);
        for (let ii = 0; ii < connectionIds.length; ii++) {
            const connectionId = connectionIds[ii];
            const pendingPeer = this.pendingPeers[connectionId];
            pendingPeer.close();
        }
        this.peers = {};
        this.pendingPeers = {};
    }
    dispatch(payload) {
        switch (payload.type) {
            case 'accept':
                const { signals } = payload;
                this.peers[payload.from] = this.initializePeer(Object.assign({ id: payload.from }, this.peerOptions));
                signals.forEach((signal) => {
                    this.dispatch(Object.assign({}, signal, { from: payload.from }));
                });
                break;
            case 'offer':
            case 'answer':
                const { type, sdp } = payload;
                const peer = this.peers[payload.from];
                peer.dispatch({ type, sdp });
                break;
            case 'offerRequest':
                this.createOfferer();
                break;
            case 'offerAccepted':
                const { connectionId } = payload;
                const persistedPeer = this.pendingPeers[connectionId];
                persistedPeer.id = payload.from;
                this.peers[payload.from] = persistedPeer;
                delete this.pendingPeers[connectionId];
                break;
            case 'candidate':
                this.peers[payload.from].dispatch({ type: payload.type, candidate: payload.candidate });
        }
    }
}
/* harmony default export */ __webpack_exports__["default"] = (FastRTCSwarm);


/***/ }),

/***/ "@mattkrick/fast-rtc-peer":
/*!*******************************************!*\
  !*** external "@mattkrick/fast-rtc-peer" ***!
  \*******************************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("@mattkrick/fast-rtc-peer");

/***/ }),

/***/ "eventemitter3":
/*!********************************!*\
  !*** external "eventemitter3" ***!
  \********************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("eventemitter3");

/***/ }),

/***/ "tslib":
/*!************************!*\
  !*** external "tslib" ***!
  \************************/
/*! no static exports found */
/***/ (function(module, exports) {

module.exports = require("tslib");

/***/ })

/******/ });
//# sourceMappingURL=FastRTCSwarm.js.map