import FastRTCPeer, { DataPayload } from '@mattkrick/fast-rtc-peer';
import EventEmitter from 'eventemitter3';
import StrictEventEmitter from 'strict-event-emitter-types';
import { PayloadToClient, PayloadToServer } from './types';
interface FastRTCSwarmEvents {
    signal: (payload: PayloadToServer) => void;
    data: (data: DataPayload, peer: FastRTCPeer) => void;
    dataOpen: (peer: FastRTCPeer) => void;
    dataClose: (peer: FastRTCPeer) => void;
    error: (error: Error, peer: FastRTCPeer) => void;
    stream: (stream: MediaStream | null, peer: FastRTCPeer) => void;
}
export declare type FastRTCSwarmEmitter = {
    new (): StrictEventEmitter<EventEmitter, FastRTCSwarmEvents>;
};
interface Options extends RTCConfiguration {
    id?: string;
}
declare const FastRTCSwarm_base: FastRTCSwarmEmitter;
declare class FastRTCSwarm extends FastRTCSwarm_base {
    peers: {
        [key: string]: FastRTCPeer;
    };
    peerOptions: RTCConfiguration;
    pendingPeers: {
        [key: string]: FastRTCPeer;
    };
    me?: string;
    isInit: boolean;
    constructor(opts?: Options);
    private createOfferer;
    private initializePeer;
    private onPeerData;
    private onPeerDataClose;
    private onPeerDataOpen;
    private onPeerStream;
    private onPeerSignal;
    broadcast(message: DataPayload): void;
    close(): void;
    dispatch(payload: PayloadToClient): void;
}
export default FastRTCSwarm;
//# sourceMappingURL=FastRTCSwarm.d.ts.map