import { CandidatePayload, OfferPayload } from '@mattkrick/fast-rtc-peer';
import { PayloadToServer } from './types';
declare global {
    interface WebSocket {
        _uuid: WebSocketID;
        _acceptedOffers: {
            [connectionId: string]: WebSocketID;
        };
        _connectionChunks: Array<ConnectionChunk>;
        _requestors: Array<WebSocket>;
        _ready: boolean;
    }
}
declare class ConnectionChunk {
    id: string;
    signals: Array<OfferPayload | CandidatePayload>;
    constructor(connectionId: string, sdp: string);
}
declare type Authorize = (from: WebSocket, to: WebSocket) => boolean;
declare type WebSocketID = string;
declare const handleWRTCSignal: (clients: WebSocket[], ws: WebSocket, payload: PayloadToServer, authorize?: Authorize) => boolean;
export default handleWRTCSignal;
//# sourceMappingURL=server.d.ts.map